spot 2.3.1

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Files Functions Variables Typedefs Enumerations Enumerator Friends Modules Pages
Public Types | Public Member Functions | Public Attributes | Protected Member Functions | Protected Attributes | List of all members
spot::couvreur99_check_result Class Referencefinal

Compute a counter example from a spot::couvreur99_check_status. More...

`#include <spot/twaalgos/gtec/ce.hh>`

Inheritance diagram for spot::couvreur99_check_result:
Collaboration diagram for spot::couvreur99_check_result:

## Public Types
typedef unsigned(unsigned_statistics::* | unsigned_fun )() const
typedef std::map< const char *, unsigned_fun, char_ptr_less_than > | stats_map

## Public Member Functions
| couvreur99_check_result (const std::shared_ptr< const couvreur99_check_status > &ecs, option_map o=option_map())
virtual twa_run_ptr | accepting_run () override
| Return a run accepted by the automata passed to the emptiness check. More...
void | print_stats (std::ostream &os) const
virtual unsigned | acss_states () const override
| Number of states in the search space for the accepting cycle. More...
const const_twa_ptr & | automaton () const
| The automaton on which an accepting_run() was found. More...
const option_map & | options () const
| Return the options parametrizing how the accepting run is computed. More...
const char * | parse_options (char *options)
| Modify the algorithm options. More...
virtual const unsigned_statistics * | statistics () const
| Return statistics, if available. More...
void | inc_ars_prefix_states ()
unsigned | ars_prefix_states () const
void | inc_ars_cycle_states ()
unsigned | ars_cycle_states () const
unsigned | get (const char *str) const

## Public Attributes
stats_map | stats

## Protected Member Functions
void | accepting_cycle ()
virtual void | options_updated (const option_map &old)
| Notify option updates. More...

## Protected Attributes
const_twa_ptr | a_
| The automaton. More...
option_map | o_
| The options. More...

## Detailed Description

Compute a counter example from a spot::couvreur99_check_status.

## Member Function Documentation

void spot::couvreur99_check_result::accepting_cycle | ( |  | ) |
| protected

Called by accepting_run() to find a cycle which traverses all acceptance conditions in the accepted SCC.

virtual twa_run_ptr spot::couvreur99_check_result::accepting_run | ( |  | ) |
| override virtual

Return a run accepted by the automata passed to the emptiness check.

This method might actually compute the acceptance run. (Not all emptiness check algorithms actually produce a counter-example as a side-effect of checking emptiness, some need some post-processing.)

This can also return 0 if the emptiness check algorithm cannot produce a counter example (that does not mean there is no counter-example; the mere existence of an instance of this class asserts the existence of a counter-example).

Reimplemented from spot::emptiness_check_result.

virtual unsigned spot::couvreur99_check_result::acss_states | ( |  | ) | const
| override virtual

Number of states in the search space for the accepting cycle.

Implements spot::acss_statistics.

const const_twa_ptr& spot::emptiness_check_result::automaton | ( |  | ) | const
| inline inherited

The automaton on which an accepting_run() was found.

const option_map& spot::emptiness_check_result::options | ( |  | ) | const
| inline inherited

Return the options parametrizing how the accepting run is computed.

virtual void spot::emptiness_check_result::options_updated | ( | const option_map & | old | ) |
| protected virtual inherited

Notify option updates.

const char* spot::emptiness_check_result::parse_options | ( | char * | options | ) |
| inherited

Modify the algorithm options.

virtual const unsigned_statistics* spot::emptiness_check_result::statistics | ( |  | ) | const
| virtual inherited

Return statistics, if available.

## Member Data Documentation

const_twa_ptr spot::emptiness_check_result::a_
| protected inherited

The automaton.

option_map spot::emptiness_check_result::o_
| protected inherited

The options.

The documentation for this class was generated from the following file:

- spot/twaalgos/gtec/ce.hh

Please direct any question, comment, or bug report to the Spot mailing list at spot@lrde.epita.fr.